diff -Naurd cluster-3.0.0.rc2/cman/qdisk/scandisk.c cluster-3.0.0.rc3/cman/qdisk/scandisk.c
--- cluster-3.0.0.rc2/cman/qdisk/scandisk.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/qdisk/scandisk.c	2009-06-11 11:02:55.000000000 +0200
@@ -574,15 +574,15 @@
 		goto found;
 
 	snprintf(newpath, sizeof(newpath), "%s/../device/media", path);
-	if (lstat(newpath, &sb))
+	if (!lstat(newpath, &sb))
 		goto found;
 
 	snprintf(newpath, sizeof(newpath), "%s/device/devtype", path);
-	if (lstat(newpath, &sb))
+	if (!lstat(newpath, &sb))
 		return 1;
 
 	snprintf(newpath, sizeof(newpath), "%s/../device/devtype", path);
-	if (lstat(newpath, &sb))
+	if (!lstat(newpath, &sb))
 		return 1;
 
 	return -1;
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/scandisk.h cluster-3.0.0.rc3/cman/qdisk/scandisk.h
--- cluster-3.0.0.rc2/cman/qdisk/scandisk.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/qdisk/scandisk.h	2009-06-11 11:02:55.000000000 +0200
@@ -13,10 +13,8 @@
 #define SYSBLOCKPATH	SYSFSPATH "/block"
 #endif
 
-#ifdef DEBUG
-#define	DEVCACHETIMEOUT	5	/* expressed in seconds */
-#else
-#define	DEVCACHETIMEOUT	30
+#ifndef	DEVCACHETIMEOUT
+#define	DEVCACHETIMEOUT	30	/* expressed in seconds */
 #endif
 
 /* each entry can be (generally):
diff -Naurd cluster-3.0.0.rc2/config/libs/libccsconfdb/ccs.h cluster-3.0.0.rc3/config/libs/libccsconfdb/ccs.h
--- cluster-3.0.0.rc2/config/libs/libccsconfdb/ccs.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/config/libs/libccsconfdb/ccs.h	2009-06-11 11:02:55.000000000 +0200
@@ -1,7 +1,3 @@
-#ifdef __CCS_COMPAT_DOT_H__
-#error DO NOT INCLUDE libccscompat.h and ccs.h at the same time. it is BAD!
-#endif
-
 #ifndef __CCS_DOT_H__
 #define __CCS_DOT_H__
 
diff -Naurd cluster-3.0.0.rc2/config/plugins/xml/Makefile cluster-3.0.0.rc3/config/plugins/xml/Makefile
--- cluster-3.0.0.rc2/config/plugins/xml/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/config/plugins/xml/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -12,7 +12,6 @@
 
 CFLAGS += -fPIC -D_GNU_SOURCE
 CFLAGS += `xml2-config --cflags`
-CFLAGS += -I${cmanincdir}/../daemon
 CFLAGS += -I${incdir}
 
 LDFLAGS += `xml2-config --libs`
diff -Naurd cluster-3.0.0.rc2/config/tools/ccs_tool/Makefile cluster-3.0.0.rc3/config/tools/ccs_tool/Makefile
--- cluster-3.0.0.rc2/config/tools/ccs_tool/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/config/tools/ccs_tool/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -6,7 +6,7 @@
 
 include ../../../make/defines.mk
 
-all: ${TARGET1} ${TARGET2}
+all: depends ${TARGET1} ${TARGET2}
 
 include $(OBJDIR)/make/cobj.mk
 include $(OBJDIR)/make/clean.mk
@@ -32,7 +32,7 @@
 	ln -sf ${TARGET1} ${TARGET2}
 
 depends:
-	$(MAKE) -C $(OBJDIR)/cman/lib all
+	$(MAKE) -C $(OBJDIR)/config/libs/libccsconfdb all
 
 clean: generalclean
 
diff -Naurd cluster-3.0.0.rc2/dlm/libdlm/libdlm.c cluster-3.0.0.rc3/dlm/libdlm/libdlm.c
--- cluster-3.0.0.rc2/dlm/libdlm/libdlm.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/dlm/libdlm/libdlm.c	2009-06-11 11:02:55.000000000 +0200
@@ -244,7 +244,7 @@
 }
 
 /* Cleanup default lockspace */
-int dlm_pthread_cleanup()
+int dlm_pthread_cleanup(void)
 {
     struct dlm_ls_info *lsinfo = default_ls;
 
@@ -1183,7 +1183,7 @@
 }
 
 /* Multi-threaded callers normally use this */
-int dlm_pthread_init()
+int dlm_pthread_init(void)
 {
     if (open_default_lockspace())
 	return -1;
diff -Naurd cluster-3.0.0.rc2/dlm/libdlm/libdlm.h cluster-3.0.0.rc3/dlm/libdlm/libdlm.h
--- cluster-3.0.0.rc2/dlm/libdlm/libdlm.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/dlm/libdlm/libdlm.h	2009-06-11 11:02:55.000000000 +0200
@@ -220,9 +220,9 @@
  */
 
 #ifdef _REENTRANT
-extern int dlm_pthread_init();
+extern int dlm_pthread_init(void);
 extern int dlm_ls_pthread_init(dlm_lshandle_t lockspace);
-extern int dlm_pthread_cleanup();
+extern int dlm_pthread_cleanup(void);
 #endif
 
 
diff -Naurd cluster-3.0.0.rc2/dlm/libdlm/libdlm_lt.pc.in cluster-3.0.0.rc3/dlm/libdlm/libdlm_lt.pc.in
--- cluster-3.0.0.rc2/dlm/libdlm/libdlm_lt.pc.in	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/dlm/libdlm/libdlm_lt.pc.in	2009-06-11 11:02:55.000000000 +0200
@@ -3,7 +3,7 @@
 libdir=@LIBDIR@
 includedir=@INCDIR@
 
-Name: libdlm
+Name: libdlm_lt
 Version: @VERSION@
 Description: Cluster Distributed Lock Manager non-threaded library
 Requires:
diff -Naurd cluster-3.0.0.rc2/dlm/libdlmcontrol/main.c cluster-3.0.0.rc3/dlm/libdlmcontrol/main.c
--- cluster-3.0.0.rc2/dlm/libdlmcontrol/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/dlm/libdlmcontrol/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -16,7 +16,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -33,7 +33,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -48,7 +48,7 @@
 	return 0;
 }
 
-static int do_connect(char *sock_path)
+static int do_connect(const char *sock_path)
 {
 	struct sockaddr_un sun;
 	socklen_t addrlen;
@@ -86,7 +86,7 @@
 		strncpy(h->name, name, DLM_LOCKSPACE_LEN);
 }
 
-int do_dump(int cmd, char *name, char *buf)
+static int do_dump(int cmd, char *name, char *buf)
 {
 	struct dlmc_header h, *rh;
 	char *reply;
diff -Naurd cluster-3.0.0.rc2/dlm/tool/main.c cluster-3.0.0.rc3/dlm/tool/main.c
--- cluster-3.0.0.rc2/dlm/tool/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/dlm/tool/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -109,7 +109,7 @@
 	unsigned int expect_replies;
 };
 
-char *mode_str(int mode)
+static const char *mode_str(int mode)
 {
 	switch (mode) {
 	case -1:
@@ -130,7 +130,7 @@
 	return "??";
 }
 
-char *msg_str(int type)
+static const char *msg_str(int type)
 {
 	switch (type) {
 	case DLM_MSG_REQUEST:
@@ -359,7 +359,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0)
@@ -393,7 +393,7 @@
 	return join_flags;
 }
 
-void do_join(char *name)
+static void do_join(char *name)
 {
 	dlm_lshandle_t *dh;
 	uint32_t flags = 0;
@@ -423,7 +423,7 @@
 	printf("done\n");
 }
 
-void do_leave(char *name)
+static void do_leave(char *name)
 {
 	dlm_lshandle_t *dh;
 
@@ -441,7 +441,7 @@
 	printf("done\n");
 }
 
-char *pr_master(int nodeid)
+static char *pr_master(int nodeid)
 {
 	static char buf[64];
 
@@ -457,7 +457,7 @@
 	return buf;
 }
 
-char *pr_extra(uint32_t flags, int root_list, int recover_list,
+static char *pr_extra(uint32_t flags, int root_list, int recover_list,
 	       int recover_locks_count, char *first_lkid)
 {
 	static char buf[128];
@@ -476,7 +476,7 @@
 	return buf;
 }
 
-void print_rsb(char *line, struct rinfo *ri)
+static void print_rsb(char *line, struct rinfo *ri)
 {
 	char type[4], namefmt[4], *p;
 	char addr[64];
@@ -532,7 +532,7 @@
 	fprintf(stderr, "print_rsb error rv %d line \"%s\"\n", rv, line);
 }
 
-void print_lvb(char *line)
+static void print_lvb(char *line)
 {
 	char lvb[1024];
 	char type[4];
@@ -568,7 +568,7 @@
 	int nodeid, ownpid, status, grmode, rqmode, highbast, rsb_lookup, wait_type;
 };
 
-char *pr_grmode(struct lkb *lkb)
+static const char *pr_grmode(struct lkb *lkb)
 {
 	if (lkb->status == DLM_LKSTS_GRANTED || lkb->status == DLM_LKSTS_CONVERT)
 		return mode_str(lkb->grmode);
@@ -578,7 +578,7 @@
 		return "XX";
 }
 
-char *pr_rqmode(struct lkb *lkb)
+static const char *pr_rqmode(struct lkb *lkb)
 {
 	static char buf[5];
 
@@ -596,7 +596,7 @@
 	}
 }
 
-char *pr_remote(struct lkb *lkb, struct rinfo *ri)
+static const char *pr_remote(struct lkb *lkb, struct rinfo *ri)
 {
 	static char buf[64];
 
@@ -613,7 +613,7 @@
 	}
 }
 
-char *pr_wait(struct lkb *lkb)
+static const char *pr_wait(struct lkb *lkb)
 {
 	static char buf[16];
 
@@ -627,7 +627,7 @@
 	}
 }
 
-char *pr_verbose(struct lkb *lkb)
+static char *pr_verbose(struct lkb *lkb)
 {
 	static char buf[128];
 
@@ -641,13 +641,13 @@
 	return buf;
 }
 
-void print_lkb(char *line, struct rinfo *ri)
+static void print_lkb(char *line, struct rinfo *ri)
 {
 	struct lkb lkb;
 	char type[4];
 	int rv;
 
-	rv = sscanf(line, "%s %x %d %x %u %llu %x %x %d %d %d %d %d %d %u %llu %llu",
+	rv = sscanf(line, "%s %x %d %x %u %"PRIu64" %x %x %d %d %d %d %d %d %u %"PRIu64" %"PRIu64,
 		    type,
 		    &lkb.id,
 		    &lkb.nodeid,
@@ -779,7 +779,7 @@
 
 #define LOCK_LINE_MAX 1024
 
-void do_waiters(char *name, struct summary *sum)
+static void do_waiters(char *name, struct summary *sum)
 {
 	FILE *file;
 	char path[PATH_MAX];
@@ -835,7 +835,7 @@
 	fclose(file);
 }
 
-void do_lockdebug(char *name)
+static void do_lockdebug(char *name)
 {
 	struct summary summary;
 	struct rinfo info;
@@ -899,7 +899,7 @@
 	}
 }
 
-void parse_r_name(char *line, char *name)
+static void parse_r_name(char *line, char *name)
 {
 	char *p;
 	int i = 0;
@@ -917,7 +917,7 @@
 	}
 }
 
-void do_lockdump(char *name)
+static void do_lockdump(char *name)
 {
 	FILE *file;
 	char path[PATH_MAX];
@@ -947,10 +947,8 @@
 	}
 
 	/* skip the header on the first line */
-	if(!fgets(line, LOCK_LINE_MAX, file)) {
-		fprintf(stderr, "can't read %s: %s\n", path, strerror(errno));
+	if (!fgets(line, LOCK_LINE_MAX, file))
 		return;
-	}
 
 	while (fgets(line, LOCK_LINE_MAX, file)) {
 		rv = sscanf(line, "%x %d %x %u %llu %x %x %hhd %hhd %hhd %u %d %d",
@@ -1039,7 +1037,7 @@
 	return str;
 }
 
-static char *nf_check_str(uint32_t flags)
+static const char *nf_check_str(uint32_t flags)
 {
 	if (flags & DLMC_NF_CHECK_FENCING)
 		return "fence";
@@ -1053,7 +1051,7 @@
 	return "none";
 }
 
-static char *condition_str(int cond)
+static const char *condition_str(int cond)
 {
 	switch (cond) {
 	case 0:
@@ -1079,9 +1077,9 @@
 	return a->nodeid - b->nodeid;
 }
 
-static void show_nodeids(int count, struct dlmc_node *nodes)
+static void show_nodeids(int count, struct dlmc_node *nodes_in)
 {
-	struct dlmc_node *n = nodes;
+	struct dlmc_node *n = nodes_in;
 	int i;
 
 	for (i = 0; i < count; i++) {
@@ -1153,9 +1151,9 @@
 	return 0;
 }
 
-static void show_all_nodes(int count, struct dlmc_node *nodes)
+static void show_all_nodes(int count, struct dlmc_node *nodes_in)
 {
-	struct dlmc_node *n = nodes;
+	struct dlmc_node *n = nodes_in;
 	int i;
 
 	for (i = 0; i < count; i++) {
diff -Naurd cluster-3.0.0.rc2/fence/agents/alom/fence_alom.py cluster-3.0.0.rc3/fence/agents/alom/fence_alom.py
--- cluster-3.0.0.rc2/fence/agents/alom/fence_alom.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/alom/fence_alom.py	2009-06-11 11:02:55.000000000 +0200
@@ -64,8 +64,13 @@
 	fence_action(conn, options, set_power_status, get_power_status,None)
 
 	# Logout from system
-	conn.sendline("logout")
-	conn.close()
+	try:
+		conn.sendline("logout")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass	                                         
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/apc/fence_apc.py cluster-3.0.0.rc3/fence/agents/apc/fence_apc.py
--- cluster-3.0.0.rc2/fence/agents/apc/fence_apc.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/apc/fence_apc.py	2009-06-11 11:02:55.000000000 +0200
@@ -223,6 +223,8 @@
 		conn.close()
 	except exceptions.OSError:
 		pass
+	except pexpect.ExceptionPexpect:
+		pass
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/bladecenter/fence_bladecenter.py cluster-3.0.0.rc3/fence/agents/bladecenter/fence_bladecenter.py
--- cluster-3.0.0.rc2/fence/agents/bladecenter/fence_bladecenter.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/bladecenter/fence_bladecenter.py	2009-06-11 11:02:55.000000000 +0200
@@ -112,8 +112,13 @@
 	##
 	## Logout from system
 	######
-	conn.send("exit\r\n")
-	conn.close()
+	try:
+		conn.send("exit\r\n")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/drac/fence_drac5.py cluster-3.0.0.rc3/fence/agents/drac/fence_drac5.py
--- cluster-3.0.0.rc2/fence/agents/drac/fence_drac5.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/drac/fence_drac5.py	2009-06-11 11:02:55.000000000 +0200
@@ -117,8 +117,13 @@
 	##
 	## Logout from system
 	######
-	conn.sendline("exit")
-	conn.close()
+	try:
+		conn.sendline("exit")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/ldom/fence_ldom.py cluster-3.0.0.rc3/fence/agents/ldom/fence_ldom.py
--- cluster-3.0.0.rc2/fence/agents/ldom/fence_ldom.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/ldom/fence_ldom.py	2009-06-11 11:02:55.000000000 +0200
@@ -107,8 +107,13 @@
 	##
 	## Logout from system
 	######
-	conn.sendline("logout")
-	conn.close()
+	try:
+		conn.sendline("logout")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass	
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/lib/fencing.py.py cluster-3.0.0.rc3/fence/agents/lib/fencing.py.py
--- cluster-3.0.0.rc2/fence/agents/lib/fencing.py.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/lib/fencing.py.py	2009-06-11 11:02:55.000000000 +0200
@@ -442,6 +442,8 @@
 				name = "port"
 			elif name == "hostname":
 				name = "ipaddr"
+			elif name == "modulename":
+				name = "module_name"
 
 			##
 			######
diff -Naurd cluster-3.0.0.rc2/fence/agents/lpar/fence_lpar.py cluster-3.0.0.rc3/fence/agents/lpar/fence_lpar.py
--- cluster-3.0.0.rc2/fence/agents/lpar/fence_lpar.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/lpar/fence_lpar.py	2009-06-11 11:02:55.000000000 +0200
@@ -143,7 +143,7 @@
 	## Fence agent specific defaults
 	#####
 	if 0 == options.has_key("-c"):
-		options["-c"] = [ ":~>", "]\$" ]
+		options["-c"] = [ ":~>", "]\$", "\$ " ]
 
 	if 0 == options.has_key("-x"):
 		fail_usage("Failed: You have to use ssh connection (-x) to fence device")
@@ -166,8 +166,13 @@
 	##
 	## Logout from system
 	######
-	conn.send("quit\r\n")
-	conn.close()
+	try:
+		conn.send("quit\r\n")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass	                                         
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/rsa/fence_rsa.py cluster-3.0.0.rc3/fence/agents/rsa/fence_rsa.py
--- cluster-3.0.0.rc2/fence/agents/rsa/fence_rsa.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/rsa/fence_rsa.py	2009-06-11 11:02:55.000000000 +0200
@@ -65,8 +65,13 @@
 	##
 	## Logout from system
 	######
-	conn.sendline("exit")
-	conn.close()
+	try:
+		conn.sendline("exit")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass	
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/scsi/fence_scsi_test.pl cluster-3.0.0.rc3/fence/agents/scsi/fence_scsi_test.pl
--- cluster-3.0.0.rc2/fence/agents/scsi/fence_scsi_test.pl	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/scsi/fence_scsi_test.pl	2009-06-11 11:02:55.000000000 +0200
@@ -175,8 +175,23 @@
     print "  -h     Help. Prints out this usage information.\n\n";
 }
 
+sub test_tools_path
+{
+    my $tool_name = "sg_persist";
+    
+    for my $path ( split /:/, $ENV{PATH} ) {
+        if ( -f "$path/$tool_name" && -x _ ) {
+          return;
+        }
+    }
+    
+    die "No $tool_name command available, please install the sg3_utils package.\n"
+}
+
 ### MAIN #######################################################################
 
+test_tools_path;
+
 if (getopts("cdhst:v") == 0)
 {
     print_usage;
diff -Naurd cluster-3.0.0.rc2/fence/agents/virsh/fence_virsh.py cluster-3.0.0.rc3/fence/agents/virsh/fence_virsh.py
--- cluster-3.0.0.rc2/fence/agents/virsh/fence_virsh.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/virsh/fence_virsh.py	2009-06-11 11:02:55.000000000 +0200
@@ -82,8 +82,13 @@
 	fence_action(conn, options, set_power_status, get_power_status, get_outlets_status)
 
 	## Logout from system
-	conn.sendline("quit")
-	conn.close()
+	try:
+		conn.sendline("quit")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/wti/fence_wti.py cluster-3.0.0.rc3/fence/agents/wti/fence_wti.py
--- cluster-3.0.0.rc2/fence/agents/wti/fence_wti.py	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/wti/fence_wti.py	2009-06-11 11:02:55.000000000 +0200
@@ -119,8 +119,13 @@
 	##
 	## Logout from system
 	######
-	conn.send("/X"+"\r\n")
-	conn.close()
+	try:
+		conn.send("/X"+"\r\n")
+		conn.close()
+	except exceptions.OSError:
+		pass
+	except pexpect.ExceptionPexpect:
+		pass
 
 if __name__ == "__main__":
 	main()
diff -Naurd cluster-3.0.0.rc2/fence/agents/xvm/Makefile cluster-3.0.0.rc3/fence/agents/xvm/Makefile
--- cluster-3.0.0.rc2/fence/agents/xvm/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/agents/xvm/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -30,7 +30,6 @@
 		debug.o
 
 CFLAGS += -D_GNU_SOURCE
-CFLAGS += -Werror -Wstrict-prototypes -Wshadow
 CFLAGS += -I${ccsincdir} -I${cmanincdir}
 CFLAGS += -I${corosyncincdir} -I${openaisincdir}
 CFLAGS += -I${logtincdir}
diff -Naurd cluster-3.0.0.rc2/fence/fenced/config.c cluster-3.0.0.rc3/fence/fenced/config.c
--- cluster-3.0.0.rc2/fence/fenced/config.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/config.c	2009-06-11 11:02:55.000000000 +0200
@@ -24,9 +24,9 @@
 int cfgd_post_join_delay = DEFAULT_POST_JOIN_DELAY;
 int cfgd_post_fail_delay = DEFAULT_POST_FAIL_DELAY;
 int cfgd_override_time   = DEFAULT_OVERRIDE_TIME;
-char *cfgd_override_path = DEFAULT_OVERRIDE_PATH;
+const char *cfgd_override_path = DEFAULT_OVERRIDE_PATH;
 
-void read_ccs_name(char *path, char *name)
+void read_ccs_name(const char *path, char *name)
 {
 	char *str;
 	int error;
@@ -40,7 +40,7 @@
 	free(str);
 }
 
-void read_ccs_yesno(char *path, int *yes, int *no)
+void read_ccs_yesno(const char *path, int *yes, int *no)
 {
 	char *str;
 	int error;
@@ -61,7 +61,7 @@
 	free(str);
 }
 
-void read_ccs_int(char *path, int *config_val)
+void read_ccs_int(const char *path, int *config_val)
 {
 	char *str;
 	int val;
diff -Naurd cluster-3.0.0.rc2/fence/fenced/config.h cluster-3.0.0.rc3/fence/fenced/config.h
--- cluster-3.0.0.rc2/fence/fenced/config.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/config.h	2009-06-11 11:02:55.000000000 +0200
@@ -26,7 +26,7 @@
 extern int cfgd_post_join_delay;
 extern int cfgd_post_fail_delay;
 extern int cfgd_override_time;
-extern char *cfgd_override_path;
+extern const char *cfgd_override_path;
 
 #endif
 
diff -Naurd cluster-3.0.0.rc2/fence/fenced/cpg.c cluster-3.0.0.rc3/fence/fenced/cpg.c
--- cluster-3.0.0.rc2/fence/fenced/cpg.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/cpg.c	2009-06-11 11:02:55.000000000 +0200
@@ -107,7 +107,7 @@
         }
 }
 
-static char *msg_name(int type)
+static const char *msg_name(int type)
 {
 	switch (type) {
 	case FD_MSG_PROTOCOL:
@@ -1289,7 +1289,7 @@
 	}
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
@@ -1759,7 +1759,7 @@
 	struct fd_header *hd;
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
diff -Naurd cluster-3.0.0.rc2/fence/fenced/fd.h cluster-3.0.0.rc3/fence/fenced/fd.h
--- cluster-3.0.0.rc2/fence/fenced/fd.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/fd.h	2009-06-11 11:02:55.000000000 +0200
@@ -191,9 +191,9 @@
 int setup_ccs(void);
 void close_ccs(void);
 void reread_ccs(void);
-void read_ccs_name(char *path, char *name);
-void read_ccs_yesno(char *path, int *yes, int *no);
-void read_ccs_int(char *path, int *config_val);
+void read_ccs_name(const char *path, char *name);
+void read_ccs_yesno(const char *path, int *yes, int *no);
+void read_ccs_int(const char *path, int *config_val);
 int read_ccs(struct fd *fd);
 
 /* cpg.c */
@@ -266,7 +266,7 @@
 /* logging.c */
 
 void init_logging(void);
-void setup_logging();
+void setup_logging(void);
 void close_logging(void);
 
 #endif				/*  __FD_DOT_H__  */
diff -Naurd cluster-3.0.0.rc2/fence/fenced/main.c cluster-3.0.0.rc3/fence/fenced/main.c
--- cluster-3.0.0.rc2/fence/fenced/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -13,6 +13,7 @@
 static pthread_t query_thread;
 static pthread_mutex_t query_mutex;
 static struct list_head controlled_entries;
+static char default_name[8];
 
 struct client {
 	int fd;
@@ -25,7 +26,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -42,7 +43,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -335,7 +336,7 @@
 	struct fenced_node node;
 	int nodeid, rv;
 
-	fd = find_fd("default");
+	fd = find_fd(default_name);
 	if (!fd) {
 		rv = -ENOENT;
 		goto out;
@@ -360,7 +361,7 @@
 	struct fenced_domain domain;
 	int rv;
 
-	fd = find_fd("default");
+	fd = find_fd(default_name);
 	if (!fd) {
 		rv = -ENOENT;
 		goto out;
@@ -384,7 +385,7 @@
 	struct fenced_node *nodes = NULL;
 	int rv, result;
 
-	fd = find_fd("default");
+	fd = find_fd(default_name);
 	if (!fd) {
 		result = -ENOENT;
 		node_count = 0;
@@ -426,6 +427,7 @@
 	char *extra = NULL;
 	int rv, extra_len;
 
+
 	rv = do_read(client[ci].fd, &h, sizeof(h));
 	if (rv < 0) {
 		log_debug("connection %d read error %d", ci, rv);
@@ -460,13 +462,13 @@
 
 	switch (h.command) {
 	case FENCED_CMD_JOIN:
-		do_join("default");
+		do_join(default_name);
 		break;
 	case FENCED_CMD_LEAVE:
-		do_leave("default");
+		do_leave(default_name);
 		break;
 	case FENCED_CMD_EXTERNAL:
-		do_external("default", extra, extra_len);
+		do_external(default_name, extra, extra_len);
 		break;
 	case FENCED_CMD_DUMP_DEBUG:
 	case FENCED_CMD_NODE_INFO:
@@ -499,7 +501,7 @@
 	log_debug("client connection %d fd %d", i, fd);
 }
 
-static int setup_listener(char *sock_path)
+static int setup_listener(const char *sock_path)
 {
 	struct sockaddr_un addr;
 	socklen_t addrlen;
@@ -621,7 +623,7 @@
 	char path[PATH_MAX+1];
 };
 
-static void register_controlled_dir(char *path)
+static void register_controlled_dir(const char *path)
 {
 	struct controlled_entry *ce;
 
@@ -1025,6 +1027,8 @@
 	INIT_LIST_HEAD(&domains);
 	INIT_LIST_HEAD(&controlled_entries);
 
+	strcpy(default_name, "default");
+
 	read_arguments(argc, argv);
 
 	if (!daemon_debug_opt) {
@@ -1036,7 +1040,7 @@
 	}
 	lockfile();
 	init_logging();
-	log_level(LOG_INFO, "fenced %s", RELEASE_VERSION);
+	log_level(LOG_INFO, "fenced %s started", RELEASE_VERSION);
 	signal(SIGTERM, sigterm_handler);
 	set_oom_adj(-16);
 
diff -Naurd cluster-3.0.0.rc2/fence/fenced/member_cman.c cluster-3.0.0.rc3/fence/fenced/member_cman.c
--- cluster-3.0.0.rc2/fence/fenced/member_cman.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/member_cman.c	2009-06-11 11:02:55.000000000 +0200
@@ -1,5 +1,6 @@
 #include "fd.h"
 #include "config.h"
+#include <arpa/inet.h>
 #include <libcman.h>
 
 #define BUFLEN		MAX_NODENAME_LEN+1
@@ -33,6 +34,7 @@
 static int name_equal(char *name1, char *name2)
 {
 	char name3[BUFLEN], name4[BUFLEN];
+	char addr1[INET6_ADDRSTRLEN];
 	int i, len1, len2;
 
 	len1 = strlen(name1);
@@ -41,6 +43,16 @@
 	if (len1 == len2 && !strncmp(name1, name2, len1))
 		return 1;
 
+	/*
+	 * If the names are IP addresses then don't compare
+	 * what is in front of the dots.
+	 */
+	if (inet_pton(AF_INET, name1, addr1) == 0)
+		return 0;
+
+	if (inet_pton(AF_INET6, name1, addr1) == 0)
+		return 0;
+
 	memset(name3, 0, BUFLEN);
 	memset(name4, 0, BUFLEN);
 
@@ -97,7 +109,7 @@
 	if (cn)
 		return cn->cn_name;
 
-	return "unknown";
+	return NULL;
 }
 
 int name_to_nodeid(char *name)
diff -Naurd cluster-3.0.0.rc2/fence/fenced/recover.c cluster-3.0.0.rc3/fence/fenced/recover.c
--- cluster-3.0.0.rc2/fence/fenced/recover.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fenced/recover.c	2009-06-11 11:02:55.000000000 +0200
@@ -80,7 +80,7 @@
 	return num_victims;
 }
 
-static inline void close_override(int *fd, char *path)
+static inline void close_override(int *fd, const char *path)
 {
 	unlink(path);
 	if (fd) {
@@ -90,7 +90,7 @@
 	}
 }
 
-static int open_override(char *path)
+static int open_override(const char *path)
 {
 	int ret;
 	mode_t om;
@@ -176,7 +176,7 @@
 	struct timeval first, last, start, now;
 	int victim_count, last_count = 0, delay = 0;
 	struct node *node;
-	char *delay_type;
+	const char *delay_type;
 
 	if (list_empty(&fd->victims))
 		return;
@@ -244,10 +244,11 @@
 
 	master_name = nodeid_to_name(fd->master);
 
-	log_level(LOG_INFO, "fencing deferred to %s", master_name);
+	log_level(LOG_INFO, "fencing deferred to %s",
+		  master_name ? master_name : "unknown");
 }
 
-static char *fe_str(int r)
+static const char *fe_str(int r)
 {
 	switch (r) {
 	case FE_AGENT_SUCCESS:
diff -Naurd cluster-3.0.0.rc2/fence/fence_node/fence_node.c cluster-3.0.0.rc3/fence/fence_node/fence_node.c
--- cluster-3.0.0.rc2/fence/fence_node/fence_node.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fence_node/fence_node.c	2009-06-11 11:02:55.000000000 +0200
@@ -18,7 +18,7 @@
 #define FL_SIZE 32
 static struct fence_log flog[FL_SIZE];
 static int flog_count;
-static char *action = "fence";
+static const char *action = "fence";
 
 #define OPTION_STRING "UvhV"
 
@@ -81,7 +81,7 @@
 	return 0;
 }
 
-static char *fe_str(int r)
+static const char *fe_str(int r)
 {
 	switch (r) {
 	case FE_AGENT_SUCCESS:
diff -Naurd cluster-3.0.0.rc2/fence/fence_tool/fence_tool.c cluster-3.0.0.rc3/fence/fence_tool/fence_tool.c
--- cluster-3.0.0.rc2/fence/fence_tool/fence_tool.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/fence_tool/fence_tool.c	2009-06-11 11:02:55.000000000 +0200
@@ -61,7 +61,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0)
@@ -128,7 +128,7 @@
 	return count;
 }
 
-static int check_controlled_dir(char *path)
+static int check_controlled_dir(const char *path)
 {
 	DIR *d;
 	struct dirent *de;
@@ -485,7 +485,7 @@
 #define CGST_WAIT_MESSAGES	2
 #define CGST_WAIT_FENCING	3
 
-static char *wait_str(int state)
+static const char *wait_str(int state)
 {
 	switch (state) {
 	case 0:
@@ -506,7 +506,7 @@
 #define VIC_DONE_OVERRIDE       3
 #define VIC_DONE_EXTERNAL       4
 
-static char *how_str(int how)
+static const char *how_str(int how)
 {
 	switch (how) {
 	case 0:
diff -Naurd cluster-3.0.0.rc2/fence/libfenced/main.c cluster-3.0.0.rc3/fence/libfenced/main.c
--- cluster-3.0.0.rc2/fence/libfenced/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/fence/libfenced/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -15,7 +15,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -32,7 +32,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -47,7 +47,7 @@
 	return 0;
 }
 
-static int do_connect(char *sock_path)
+static int do_connect(const char *sock_path)
 {
 	struct sockaddr_un sun;
 	socklen_t addrlen;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_debug/basic.c cluster-3.0.0.rc3/gfs/gfs_debug/basic.c
--- cluster-3.0.0.rc2/gfs/gfs_debug/basic.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_debug/basic.c	2009-06-11 11:02:55.000000000 +0200
@@ -171,7 +171,7 @@
 	unsigned int bn = 0;
 	unsigned int bit;
 	unsigned char value;
-	char *type;
+	const char *type;
 
 	printf("\n");
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_debug/readfile.c cluster-3.0.0.rc3/gfs/gfs_debug/readfile.c
--- cluster-3.0.0.rc2/gfs/gfs_debug/readfile.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_debug/readfile.c	2009-06-11 11:02:55.000000000 +0200
@@ -189,7 +189,7 @@
 
 static void
 do_readdir(struct gfs_dinode *di, char *data,
-	   uint32_t index, uint32_t len, uint64_t leaf_no,
+	   uint32_t lindex, uint32_t len, uint64_t leaf_no,
 	   void *opaque)
 {
 	struct gfs_leaf leaf;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_debug/util.c cluster-3.0.0.rc3/gfs/gfs_debug/util.c
--- cluster-3.0.0.rc2/gfs/gfs_debug/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_debug/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -89,7 +89,7 @@
 	struct gfs_leaf leaf;
 	uint32_t hsize, len;
 	uint32_t ht_offset, lp_offset, ht_offset_cur = -1;
-	uint32_t index = 0;
+	uint32_t lindex = 0;
 	uint64_t lp[sd_hash_ptrs];
 	uint64_t leaf_no;
 	int error;
@@ -98,9 +98,9 @@
 	if (hsize * sizeof(uint64_t) != di->di_size)
 		die("bad hash table size\n");
 
-	while (index < hsize) {
-		lp_offset = index % sd_hash_ptrs;
-		ht_offset = index - lp_offset;
+	while (lindex < hsize) {
+		lp_offset = lindex % sd_hash_ptrs;
+		ht_offset = lindex - lp_offset;
 
 		if (ht_offset_cur != ht_offset) {
 			error = gfs_readi(di, (char *)lp, ht_offset * sizeof(uint64_t), sd_hash_bsize);
@@ -117,13 +117,13 @@
 		gfs_leaf_in(&leaf, data);
 		len = 1 << (di->di_depth - leaf.lf_depth);
 
-		lc(di, data, index, len, leaf_no, opaque);
+		lc(di, data, lindex, len, leaf_no, opaque);
 
 		free(data);
-		index += len;
+		lindex += len;
 	}
 
-	if (index != hsize)
+	if (lindex != hsize)
 		die("screwed up directory\n");
 }
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/eattr.c cluster-3.0.0.rc3/gfs/gfs_fsck/eattr.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/eattr.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/eattr.c	2009-06-11 11:02:55.000000000 +0200
@@ -1,7 +1,7 @@
 #include <stdint.h>
 
 #include "fsck_incore.h"
-
+#include "eattr.h"
 
 static int clear_blk_nodup(struct fsck_sb *sbp, uint64_t block)
 {
